(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('rxjs'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', 'rxjs', '@angular/common'], factory) :
	(factory((global.ngxUeditor = {}),global.ng.core,global.ng.forms,global.rxjs,global.ng.common));
}(this, (function (exports,core,forms,rxjs,common) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ScriptService = /** @class */ (function () {
    function ScriptService() {
        this.loaded = false;
        this.list = {};
        this.emitter = new rxjs.Subject();
    }
    /**
     * @return {?}
     */
    ScriptService.prototype.getChangeEmitter = /**
     * @return {?}
     */
    function () {
        return this.emitter;
    };
    /**
     * @param {?} path
     * @return {?}
     */
    ScriptService.prototype.load = /**
     * @param {?} path
     * @return {?}
     */
    function (path) {
        var _this = this;
        if (this.loaded)
            return this;
        this.loaded = true;
        var /** @type {?} */ promises = [];
        path.forEach(function (script) { return promises.push(_this.loadScript(script)); });
        Promise.all(promises).then(function (res) {
            _this.emitter.next(true);
        });
        return this;
    };
    /**
     * @param {?} path
     * @return {?}
     */
    ScriptService.prototype.loadScript = /**
     * @param {?} path
     * @return {?}
     */
    function (path) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (_this.list[path] === true) {
                resolve(/** @type {?} */ ({
                    path: path,
                    loaded: true,
                    status: 'Loaded',
                }));
                return;
            }
            _this.list[path] = true;
            var /** @type {?} */ node = document.createElement('script');
            node.type = 'text/javascript';
            node.src = path;
            node.charset = 'utf-8';
            if (node.readyState) {
                // IE
                node.onreadystatechange = function () {
                    if (node.readyState === 'loaded' || node.readyState === 'complete') {
                        node.onreadystatechange = null;
                        resolve(/** @type {?} */ ({
                            path: path,
                            loaded: true,
                            status: 'Loaded',
                        }));
                    }
                };
            }
            else {
                node.onload = function () {
                    resolve(/** @type {?} */ ({
                        path: path,
                        loaded: true,
                        status: 'Loaded',
                    }));
                };
            }
            node.onerror = function (error) {
                return resolve(/** @type {?} */ ({
                    path: path,
                    loaded: false,
                    status: 'Loaded',
                }));
            };
            document.getElementsByTagName('head')[0].appendChild(node);
        });
    };
    ScriptService.decorators = [
        { type: core.Injectable },
    ];
    return ScriptService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */

var UEditorConfig = /** @class */ (function () {
    function UEditorConfig() {
    }
    return UEditorConfig;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var _hook_finished = false;
var UEditorComponent = /** @class */ (function () {
    function UEditorComponent(el, ss, cog, cd) {
        this.el = el;
        this.ss = ss;
        this.cog = cog;
        this.cd = cd;
        this.inited = false;
        this.events = {};
        this.loading = true;
        this.id = "_ueditor-" + Math.random()
            .toString(36)
            .substring(2);
        this.loadingTip = '加载中...';
        this.onPreReady = new core.EventEmitter();
        this.onReady = new core.EventEmitter();
        this.onDestroy = new core.EventEmitter();
        this.onContentChange = new core.EventEmitter();
        this.onChange = Function.prototype;
        this.onTouched = Function.prototype;
    }
    /**
     * @return {?}
     */
    UEditorComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.inited = true;
    };
    /**
     * @return {?}
     */
    UEditorComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // 已经存在对象无须进入懒加载模式
        if (window.UE) {
            this.init();
            return;
        }
        this.ss
            .load(this.cog.js)
            .getChangeEmitter()
            .subscribe(function (res) {
            _this.init();
        });
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    UEditorComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (this.inited && changes["config"]) {
            this.destroy();
            this.init();
        }
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    UEditorComponent.prototype.init = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        var _this = this;
        if (!window.UE)
            throw new Error('uedito js文件加载失败');
        if (this.instance)
            return;
        // registrer hook
        if (this.cog.hook && !_hook_finished) {
            _hook_finished = true;
            this.cog.hook(UE);
        }
        this.onPreReady.emit(this);
        var /** @type {?} */ opt = Object.assign({}, this.cog.options, this.config, options);
        var /** @type {?} */ ueditor = UE.getEditor(this.id, opt);
        ueditor.ready(function () {
            _this.instance = ueditor;
            if (_this.value)
                _this.instance.setContent(_this.value);
            _this.onReady.emit(_this);
        });
        ueditor.addListener('contentChange', function () {
            _this.value = ueditor.getContent();
            _this.onChange(_this.value);
            _this.onTouched(_this.value);
            _this.onContentChange.emit(_this.value);
        });
        this.loading = false;
        this.cd.detectChanges();
    };
    /**
     * @return {?}
     */
    UEditorComponent.prototype.destroy = /**
     * @return {?}
     */
    function () {
        if (this.instance) {
            for (var _i = 0, _a = this.events; _i < _a.length; _i++) {
                var ki = _a[_i];
                this.instance.removeListener(ki, this.events[ki]);
            }
            this.instance.removeListener('ready');
            this.instance.removeListener('contentChange');
            this.instance.destroy();
            this.instance = null;
        }
        this.onDestroy.emit();
    };
    Object.defineProperty(UEditorComponent.prototype, "Instance", {
        /**
         * 获取UE实例
         *
         * @readonly
         */
        get: /**
         * 获取UE实例
         *
         * \@readonly
         * @return {?}
         */
        function () {
            return this.instance;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * 设置编辑器语言
     *
     * @param {('zh-cn' | 'en')} lang
     */
    /**
     * 设置编辑器语言
     *
     * @param {?} lang
     * @return {?}
     */
    UEditorComponent.prototype.setLanguage = /**
     * 设置编辑器语言
     *
     * @param {?} lang
     * @return {?}
     */
    function (lang) {
        var _this = this;
        this.ss
            .loadScript(this.cog.options.UEDITOR_HOME_URL + "/lang/" + lang + "/" + lang + ".js")
            .then(function (res) {
            _this.destroy();
            // 清空语言
            if (!UE._bak_I18N) {
                UE._bak_I18N = UE.I18N;
            }
            UE.I18N = {};
            UE.I18N[lang] = UE._bak_I18N[lang];
            _this.init();
        });
    };
    /**
     * 添加编辑器事件
     */
    /**
     * 添加编辑器事件
     * @param {?} eventName
     * @param {?} fn
     * @return {?}
     */
    UEditorComponent.prototype.addListener = /**
     * 添加编辑器事件
     * @param {?} eventName
     * @param {?} fn
     * @return {?}
     */
    function (eventName, fn) {
        if (this.events[eventName])
            return;
        this.events[eventName] = fn;
        this.instance.addListener(eventName, fn);
    };
    /**
     * 移除编辑器事件
     */
    /**
     * 移除编辑器事件
     * @param {?} eventName
     * @return {?}
     */
    UEditorComponent.prototype.removeListener = /**
     * 移除编辑器事件
     * @param {?} eventName
     * @return {?}
     */
    function (eventName) {
        if (!this.events[eventName])
            return;
        this.instance.removeListener(eventName, this.events[eventName]);
        delete this.events[eventName];
    };
    /**
     * @return {?}
     */
    UEditorComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroy();
    };
    // reuse-tab: http://ng-alain.com/components/reuse-tab#%E7%94%9F%E5%91%BD%E5%91%A8%E6%9C%9F
    /**
     * @return {?}
     */
    UEditorComponent.prototype._onReuseInit = /**
     * @return {?}
     */
    function () {
        this.destroy();
        this.init();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    UEditorComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.value = value;
        if (this.instance) {
            this.instance.setContent(this.value);
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    UEditorComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    UEditorComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    UEditorComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        if (isDisabled) {
            this.instance.setDisabled();
        }
        else {
            this.instance.setEnabled();
        }
    };
    UEditorComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ueditor',
                    template: "\n    <textarea #host id=\"{{id}}\" class=\"ueditor-textarea\"></textarea>\n    <div class=\"loading\" *ngIf=\"loading\" [innerHTML]=\"loadingTip\"></div>\n    ",
                    styles: [":host .ueditor-textarea{display:none;}"],
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return UEditorComponent; }),
                            multi: true,
                        },
                    ],
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                },] },
    ];
    /** @nocollapse */
    UEditorComponent.ctorParameters = function () { return [
        { type: core.ElementRef, },
        { type: ScriptService, },
        { type: UEditorConfig, },
        { type: core.ChangeDetectorRef, },
    ]; };
    UEditorComponent.propDecorators = {
        "config": [{ type: core.Input },],
        "loadingTip": [{ type: core.Input },],
        "host": [{ type: core.ViewChild, args: ['host',] },],
        "onPreReady": [{ type: core.Output },],
        "onReady": [{ type: core.Output },],
        "onDestroy": [{ type: core.Output },],
        "onContentChange": [{ type: core.Output },],
    };
    return UEditorComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var UEditorModule = /** @class */ (function () {
    function UEditorModule() {
    }
    /**
     * @param {?} config
     * @return {?}
     */
    UEditorModule.forRoot = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: UEditorModule,
            providers: [{ provide: UEditorConfig, useValue: config }],
        };
    };
    UEditorModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    providers: [ScriptService],
                    declarations: [UEditorComponent],
                    exports: [UEditorComponent],
                },] },
    ];
    return UEditorModule;
}());

exports.UEditorComponent = UEditorComponent;
exports.UEditorConfig = UEditorConfig;
exports.UEditorModule = UEditorModule;
exports.ɵa = ScriptService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ueditor.umd.js.map
